"use strict";

var lockCall = function lockCall(uuid, func, args) {
  var done = false;
  spinDo(function () {
    window.dLock = window.dLock || {};

    if (dLock[uuid]) {
      throw new Error('');
    }

    dLock[uuid] = true;

    try {
      func.apply(void 0, args);
    } finally {
      dLock[uuid] = false;
      done = true;
    }
  });
};

var spinDo = function spinDo(handler, interval, tryCnt) {
  interval = interval || 100;
  tryCnt = tryCnt || 20;
  var cnt = 0;
  var error0;
  var timer = setInterval(function () {
    var error;

    try {
      handler();
      clearInterval(timer);
    } catch (e) {
      // ignore
      cnt++;
      error = e;
      error0 = error0 || e;
    }

    if (cnt == tryCnt) {
      clearInterval(timer); // 首次和最后一次报错比较关键

      console.error('spinDo fail...', error0, error);
    }
  }, interval);
};

module.exports = {
  lockCall: lockCall,
  spinDo: spinDo
};